<html>
<HEAD>
<TITLE></TITLE>
<META HTTP-EQUIV="refresh" CONTENT="10">
</HEAD>
<body>
<table border="1" width="400">
<tr>
<th colspan="2">SDR test</th>
</tr>

<?php
#AFEDRi SDR-Net control utility
#author Alexander Trushkin 4Z5LV
# Enjoy
$host = "192.168.0.8";
#$host = "10.0.0.6";
$port = 50000;
$rlen = 128;
#$frequency = 0;
#$rf_gain = 11;
$channel = 0;
$request_name = "\x04\x20\x01\x00";
$request_sn = "\x09\xE0\x02\x1D\x00\x00\x00\x00\x00";
$request_fw = "\x09\xE0\x02\x09\x00\x00\x00\x00\x00";
$request_hw = "\x09\xE0\x02\x25\x00\x00\x00\x00\x00";
$request_sr = "\x09\xE0\x02\x0E\x5A\x00\x00\x00\x00";
$request_mcmode = "\x09\xE0\x02\x0F\x00\x00\x00\x00\x00";
#$request_mclock = "\x09\xE0\x02\x43\x00\x00\x00\x00\x00";
$request_mclock = "\x04\x20\xB0\x00";
#$request_lo_freq = "\x05\x20\x20\x00\0x00";
$request_lo_freq = "\x09\xE0\x02\x01\x00\x00\x00\x00\x00";
$request_vhf_clock = "\x09\xE0\x02\x5B\x00\x00\x00\x00\x00";
$response = "";
$fp = fsockopen($host, $port, $errno, $errstr, 30);
if (!$fp) {
    echo "<tr><td><font color=\"red\">Cannot find SDR, $errstr ($errno)<br /></font></td></tr>\n";
} else {
    echo "<tr><td>Next SDR was found: </td>\n";
#SDR Model Name
    fwrite($fp, $request_name);
    $response =fread($fp,$rlen);
    $sdr_name = substr($response, 4);
    echo "<td>".$sdr_name."</td></tr>"; 
#Serial number
    fwrite($fp, $request_sn);
    $response= fread($fp,$rlen);
    echo "<tr><td>Serial number:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("V",$sdr_sn_t);
#    $sdr_sn = bin2hex(sdr_sn_t);
    printf("<td>%X</td></tr>", $sdr_sn[1]);
#Firmware request
    fwrite($fp, $request_fw);
    $response= fread($fp,$rlen);
    echo "<tr><td>Firmware version:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%X</td></tr>", $sdr_sn[1]);
#Hardware request
    fwrite($fp, $request_hw);
    $response= fread($fp,$rlen);
    echo "<tr><td>Hardware version:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%X</td></tr>", $sdr_sn[1]);
#Main clock request
    fwrite($fp, $request_mclock);
    $response= fread($fp,$rlen);
    echo "<tr><td>Main clock:</td>";
    $sdr_sn_t = substr($response, 5);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%lu</td></tr>", $sdr_sn[1]);
#Sample rate request
    fwrite($fp, $request_sr);
    $response= fread($fp,$rlen);
    echo "<tr><td>Sample rate:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%lu</td></tr>", $sdr_sn[1]);
#VHF clock
    fwrite($fp, $request_vhf_clock);
    $response= fread($fp,$rlen);
    echo "<tr><td>VHF clock:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%lu</td></tr>", $sdr_sn[1]);
#Multichannel mode request
    fwrite($fp, $request_mcmode);
    $response= fread($fp,$rlen);
    echo "<tr><td>Multichannel mode:</td>";
    $sdr_sn_t = substr($response, 4);
    $sdr_sn = unpack("c",$sdr_sn_t);
    switch($sdr_sn[1])
    {
	case 0:
	    $mcmode = "Single Channel mode";
	    break;
	case 1:
	    $mcmode = "Diversity (Dual channel) mode";
	    break;
	case 2:
	    $mcmode = "Dual Channel mode";
	    break;
	case 3:
	    $mcmode = "Diversity (Single Channel) mode";
	    break;
	case 4:
	    $mcmode = "Diversity (Quad Channel) mode";
	    break;
	case 5:
	    $mcmode = "Quad Channel mode";
	    break;
    }
    printf("<td>%s (%d) </td></tr>", $mcmode, $sdr_sn[1]);
#LO frequency 
    fwrite($fp, $request_lo_freq);
    $response= fread($fp,$rlen);
    echo "<tr><td>Central (LO) Frequency:</td>";
    $sdr_sn_t = substr($response, 3);
    $sdr_sn = unpack("V",$sdr_sn_t);
    printf("<td>%lu</td></tr>", $sdr_sn[1]);
}
?>
</table>
<br />
<br />
<br />
<br />
<?php
if ($_SERVER['REQUEST_METHOD'] === 'POST') 
{
    $rf_gain = $_POST['RF_Gain'];
    $frequency = $_POST['Frequency'];
    $channel = (int)$_POST['channel_number'];
    if (isset($_POST['btnFrequency'])) 
    {
	$message = send_new_frequency($frequency);
    } 
    elseif(isset($_POST['btnRFGain']))
    {
	$message = send_new_rf_gain($channel,$rf_gain);
    }
}
?>
<form method="post">
<select name="channel_number">
    <option value="0" <?php if($channel == 0) {echo "selected";} ?>>Channel 1</option>
    <option value="1" <?php if($channel == 1) {echo "selected";} ?>>Channel 2</option>
    <option value="2" <?php if($channel == 2) {echo "selected";} ?>>Channel 3</option>
    <option value="3" <?php if($channel == 3) {echo "selected";} ?>>Channel 4</option>
</select>
<table width="400">
<tr>
<td><?php echo "<input type=\"text\" name=\"Frequency\" value=\"".$frequency."\" size=\"20\"/>" ?> </td>
<td><?php echo "<input type=\"submit\" name=\"btnFrequency\" value=\"Set Frequency (Hz)\"  />" ?> </td>
</tr>
<tr>
<td><?php echo "<input type=\"text\" name=\"RF_Gain\" value=\"".$rf_gain."\" />" ?> </td>
<td><?php echo "<input type=\"submit\" name=\"btnRFGain\" value=\"Set RF Gain (dB)\"  />" ?> </td>
</tr>
<tr>
<td colspan="2"><?php echo "<input type=\"text\" name=\"job\" value=\"".$message." (".$channel.")"."\" size=\"60\" readonly />" ?></td> 
</tr>
</table>
</form>

<?php
#finish
    echo "<br /> \n Close connection! \n<br /n>";
    fclose($fp);
?>
<?php
function send_new_frequency($new_frequency)
{
    global $host, $port, $rlen ;    
    $fp = fsockopen($host, $port, $errno, $errstr, 30);
    if (!$fp)	return  "Cannot find SDR, $errstr ($errno)\n";
#    $fp = fopen("tcp.txt","w+");
    $out_stream = pack("H*lc","0A00200000",$new_frequency,0);
#    $out_stream = pack("H*H*H*H*cl","0A","00","20","00","00",$new_frequency);
    fwrite($fp, $out_stream);
    fclose($fp);
    if($response === FALSE) return "No response from SDR";
    $n_message = "The new frequency has been sent to SDR";
    return $n_message;
}
function send_new_rf_gain($channel, $new_gain)
{
    global $host, $port, $rlen ;    
    if(($new_gain >= -10) && ($new_gain <= 35))
    {  
	$fp = fsockopen($host, $port, $errno, $errstr, 30);
	if (!$fp)
	{
	     return  "Cannot find SDR, $errstr ($errno)\n";
	}
#	$fp = fopen("tcp.txt","w+");
	$rf_gain = ((10+$new_gain)*8)/3 + 1;
	$out_stream = pack("H*cc","06003800",$channel,$rf_gain);
	fwrite($fp, $out_stream);
        $response= fread($fp,$rlen);
	fclose($fp);
	if($response === FALSE) return "No response from SDR";
	$n_message = "The new RF Gain has been sent to SDR";
    }
    else
    {
	$n_message = "RF Gain is out of range, use (-10dB <> 35dB)";	
    }
    return $n_message;
}
?>
</body>
</html>
